classification
Title: android: test_importlib hangs on armv7
Type: behavior Stage: resolved
Components: Cross-Build, Tests Versions: Python 3.7, Python 3.6
process
Status: closed Resolution: fixed
Dependencies: 26939 Superseder:
Assigned To: xdegaye Nosy List: Alex.Willmer, brett.cannon, python-dev, xdegaye
Priority: normal Keywords: patch

Created on 2016-05-03 15:42 by xdegaye, last changed 2016-12-08 11:03 by xdegaye. This issue is now closed.

Files
File name Uploaded Description Edit
test_importlib_gdb_bt.txt xdegaye, 2016-05-06 19:34 gdb back trace
setswitchinterval.patch xdegaye, 2016-10-28 07:25 review
Messages (5)
msg264743 - (view) Author: Xavier de Gaye (xdegaye) * (Python committer) Date: 2016-05-03 15:42
test_importlib hangs on an android emulator running an armv7 system image (but not on x86) at API level 21. The test suite hangs at

test_deadlock (test.test_importlib.test_locks.Frozen_DeadlockAvoidanceTests) ...

A cause of this problem may be related to the fact that the android arm emulator runs very, very slowly.
msg264758 - (view) Author: Xavier de Gaye (xdegaye) * (Python committer) Date: 2016-05-03 19:10
Interestingly, all the tests (issues #26938, #26939, #26940 and #26941) that hang on arm use sys.setswitchinterval() aggressively.
msg265011 - (view) Author: Xavier de Gaye (xdegaye) * (Python committer) Date: 2016-05-06 19:34
Adding gdb backtrace.
msg279589 - (view) Author: Xavier de Gaye (xdegaye) * (Python committer) Date: 2016-10-28 07:25
Adding a dependency to issue 26939.
Patch attached.
msg282704 - (view) Author: Roundup Robot (python-dev) Date: 2016-12-08 10:28
New changeset 1bb2f4b8440e by Xavier de Gaye in branch '3.6':
Issue #26940: Fix test_importlib that hangs on the Android armv7 qemu emulator.
https://hg.python.org/cpython/rev/1bb2f4b8440e

New changeset e401c5a95758 by Xavier de Gaye in branch 'default':
Issue #26940: Merge 3.6.
https://hg.python.org/cpython/rev/e401c5a95758
History
Date User Action Args
2016-12-08 11:03:07xdegayesetstatus: open -> closed
resolution: fixed
stage: commit review -> resolved
2016-12-08 10:28:05python-devsetnosy: + python-dev
messages: + msg282704
2016-11-17 16:29:26xdegayesetstage: patch review -> commit review
2016-10-28 07:25:09xdegayesetfiles: + setswitchinterval.patch

dependencies: + android: test_functools hangs on armv7
assignee: xdegaye
components: + Tests, - Library (Lib)
versions: + Python 3.7
keywords: + patch
messages: + msg279589
stage: patch review
2016-05-21 07:06:39xdegayelinkissue26865 dependencies
2016-05-06 19:34:06xdegayesetfiles: + test_importlib_gdb_bt.txt

messages: + msg265011
2016-05-03 19:10:58xdegayesetmessages: + msg264758
2016-05-03 15:42:14xdegayecreate